SystemOrganization addCategory: #'GT-Debugger-EventRecorder'!

!GTStepToBytecodeDebugAction methodsFor: '*GT-Debugger-EventRecorder' stamp: 'RogerStebler 3/15/2016 15:55'!
asRecorderEvent

	^ GTStepToBytecodeDebugActionEvent fromDebugAction: self! !

!GTGoAndInspectBytecodeDebugAction methodsFor: '*GT-Debugger-EventRecorder' stamp: 'RogerStebler 3/15/2016 15:55'!
asRecorderEvent

	^ GTGoAndInspectBytecodeDebugActionEvent fromDebugAction: self! !

!GTGenericStackDebuggerSelectionChanged methodsFor: '*GT-Debugger-EventRecorder' stamp: 'RogerStebler 3/15/2016 15:55'!
asRecorderEvent

	^ GTGenericStackDebuggerSelectionChangedEvent fromAnnouncement: self! !

!DebugAction methodsFor: '*GT-Debugger-EventRecorder' stamp: 'RogerStebler 3/15/2016 15:55'!
asRecorderEvent

	^ GTDebuggerDebugActionEvent fromDebugAction: self! !

!RunToSelectionDebugAction methodsFor: '*GT-Debugger-EventRecorder' stamp: 'RogerStebler 3/15/2016 15:55'!
asRecorderEvent

	^ RunToSelectionDebugActionEvent fromDebugAction: self! !

!GLMBrowserClosing methodsFor: '*GT-Debugger-EventRecorder' stamp: 'AndreiChis 1/29/2016 15:00'!
asRecorderEvent

	^ GLMRecorderBrowserClosingEvent fromAnnouncement: self! !

!GTChangeDebuggerAction methodsFor: '*GT-Debugger-EventRecorder' stamp: 'RogerStebler 3/15/2016 15:55'!
asRecorderEvent

	^ GTDebuggerChangeDebuggerEvent fromDebugAction: self! !

!GTGlamourWrapperDebuggingAction methodsFor: '*GT-Debugger-EventRecorder' stamp: 'RogerStebler 3/15/2016 15:55'!
asRecorderEvent

	^ GTGlamourWrapperDebuggingActionEvent fromDebugAction: self! !

GTEventCollector subclass: #GTDebuggerEventCollector
	instanceVariableNames: 'announcer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-EventRecorder'!

!GTDebuggerEventCollector methodsFor: 'initialization' stamp: 'RogerStebler 3/1/2016 18:41'!
initialize
	super initialize.	
	recordedEvents := SharedQueue  new.! !

!GTDebuggerEventCollector methodsFor: 'initialization' stamp: 'AndreiChis 1/29/2016 14:16'!
linkToDebugger: aDebugger

	aDebugger announcer weak when: Announcement send: #recordAnnouncement: to: self! !

!GTDebuggerEventCollector methodsFor: 'events' stamp: 'RogerStebler 3/17/2016 13:57'!
recordAnnouncement: anAnnouncement
	| event |
	Privacy sendDiagnosticsAndUsageData ifFalse: [ ^ self ].
	(anAnnouncement respondsTo: #asRecorderEvent) ifTrue: [	
		event := anAnnouncement asRecorderEvent.
		self add: event.
		GTEventRecorder uniqueInstance announcer announce: (DebuggerEventRecorded forEvent: event). ]! !

!GTDebuggerEventCollector methodsFor: 'events' stamp: 'RogerStebler 3/17/2016 13:57'!
recordDebuggerOpenEventFor: aDebugger
	| event |
	Privacy sendDiagnosticsAndUsageData ifFalse: [ ^ self ].
	event := GTDebuggerRecorderOpenEvent new fromDebugger: aDebugger.
	self add: event.
	GTEventRecorder uniqueInstance announcer announce: (DebuggerEventRecorded forEvent: event).! !

Announcement subclass: #DebuggerEventRecorded
	instanceVariableNames: 'recordedEvent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-EventRecorder'!

!DebuggerEventRecorded class methodsFor: 'instance creation' stamp: 'RogerStebler 3/1/2016 17:48'!
forEvent: aRecorderEvent
	^ self new
		recordedEvent: aRecorderEvent;
		yourself.! !

!DebuggerEventRecorded methodsFor: 'accessing' stamp: 'RogerStebler 3/1/2016 17:50'!
recordedEvent
	^ recordedEvent! !

!DebuggerEventRecorded methodsFor: 'accessing' stamp: 'RogerStebler 3/1/2016 17:50'!
recordedEvent: aRecorderEvent
	recordedEvent := aRecorderEvent! !

!GTRunToSelectionDebugAction methodsFor: '*GT-Debugger-EventRecorder' stamp: 'RogerStebler 3/15/2016 15:55'!
asRecorderEvent

	^ GTRunToSelectionDebugActionEvent fromDebugAction: self! !

!MessageSendDebugAction methodsFor: '*GT-Debugger-EventRecorder' stamp: 'RogerStebler 3/15/2016 15:55'!
asRecorderEvent

	^ MessageSendDebugActionEvent fromDebugAction: self! !

!DebugActionExecuted methodsFor: '*GT-Debugger-EventRecorder' stamp: 'RogerStebler 3/11/2016 13:54'!
asRecorderEvent

	^ (debuggingAction asRecorderEvent fromAnnouncement: self)
		isExecuted: true;
		yourself! !

Object subclass: #GTDebuggerRecorderEvent
	instanceVariableNames: 'timestamp info'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-EventRecorder'!

GTDebuggerRecorderEvent subclass: #GLMRecorderBrowserClosingEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-EventRecorder'!

!GLMRecorderBrowserClosingEvent methodsFor: 'initialization' stamp: 'RogerStebler 3/15/2016 16:10'!
fromAnnouncement: anAnnouncement
	super fromAnnouncement: anAnnouncement.
	
	self addWindowHashFor: anAnnouncement presentation.! !

GTDebuggerRecorderEvent subclass: #GTDebuggerDebugActionEvent
	instanceVariableNames: 'isExecuted'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-EventRecorder'!

GTDebuggerDebugActionEvent subclass: #GTCodeDebugActionEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-EventRecorder'!

!GTCodeDebugActionEvent methodsFor: 'initialization' stamp: 'RogerStebler 3/12/2016 14:40'!
fromDebugAction: aDebugAction
	super fromDebugAction: aDebugAction.
	self infoAt: #selection put: aDebugAction debugger selectionInterval.! !

GTDebuggerDebugActionEvent subclass: #GTDebuggerChangeDebuggerEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-EventRecorder'!

!GTDebuggerChangeDebuggerEvent methodsFor: 'private' stamp: 'RogerStebler 3/5/2016 16:02'!
addNewWindowHashFor: aPresentation

	aPresentation window ifNotNil: [ :aWindow |
		self infoAt: #newWindowHash put: aWindow identityHash ]! !

!GTDebuggerChangeDebuggerEvent methodsFor: 'initialization' stamp: 'RogerStebler 3/11/2016 14:05'!
fromDebugAction: aDebugAction
	super fromDebugAction: aDebugAction.
	aDebugAction newDebugger isNotNil ifTrue: [ self addNewWindowHashFor: aDebugAction newDebugger ]! !

!GTDebuggerDebugActionEvent class methodsFor: 'instance creation' stamp: 'RogerStebler 3/15/2016 15:52'!
fromDebugAction: aDebugAction

	^ self new fromDebugAction: aDebugAction! !

!GTDebuggerDebugActionEvent methodsFor: 'accessing' stamp: 'RogerStebler 3/9/2016 14:34'!
= otherGTDebuggerDebugActionEvent
	(otherGTDebuggerDebugActionEvent isKindOf: self class) ifFalse: [ ^ false ].
	(self infoAt: #debugActionClass) == (otherGTDebuggerDebugActionEvent infoAt: #debugActionClass) ifFalse: [ ^ false ].
	(self infoAt: #methodClass) == (otherGTDebuggerDebugActionEvent infoAt: #methodClass) ifFalse: [ ^ false ].
	(self infoAt: #methodSelector) == (otherGTDebuggerDebugActionEvent infoAt: #methodSelector) ifFalse: [ ^ false ].
	(self infoAt: #pc) == (otherGTDebuggerDebugActionEvent infoAt: #pc) ifFalse: [ ^ false ].
	(self infoAt: #windowHash) == (otherGTDebuggerDebugActionEvent infoAt: #windowHash) ifFalse: [ ^ false ].
	^ true! !

!GTDebuggerDebugActionEvent methodsFor: 'accessing' stamp: 'RogerStebler 2/29/2016 15:11'!
asDebugActionFor: aDebugger
	| actionClass |
	actionClass := (info at: #debugActionClass) asSymbol asClass.
	(actionClass respondsTo: #gtGlobalDebuggingActionFor:) ifTrue: [
		^ actionClass gtGlobalDebuggingActionFor: aDebugger ].
	^ nil! !

!GTDebuggerDebugActionEvent methodsFor: 'initialization' stamp: 'RogerStebler 3/3/2016 17:12'!
fromDebugAction: aDebugAction
	self infoAt: #debugActionClass put: aDebugAction class name.
	self infoAt: #methodClass put: aDebugAction currentContext methodClass name.
	self infoAt: #methodSelector put: aDebugAction currentContext methodSelector.
	self infoAt: #pc put: aDebugAction currentContext pc.
	self addWindowHashFor: aDebugAction debugger.! !

!GTDebuggerDebugActionEvent methodsFor: 'testing' stamp: 'RogerStebler 3/5/2016 15:17'!
isAboutToExectute
	^ self isExecuted not! !

!GTDebuggerDebugActionEvent methodsFor: 'testing' stamp: 'RogerStebler 3/4/2016 14:58'!
isActionForClass: aClassName Method: aMethodName PC: anInteger
	((self infoAt: #methodClass) == aClassName) ifFalse: [ ^ false ].
	((self infoAt: #methodSelector) == aMethodName) ifFalse: [ ^ false ].
	((self infoAt: #pc) == anInteger) ifFalse: [ ^ false ].
	^ true.! !

!GTDebuggerDebugActionEvent methodsFor: 'testing' stamp: 'RogerStebler 3/7/2016 16:25'!
isActionForContext: aContext
	^ self isActionForClass: aContext methodClass name Method: aContext methodSelector PC: aContext pc.! !

!GTDebuggerDebugActionEvent methodsFor: 'testing' stamp: 'RogerStebler 3/11/2016 13:53'!
isExecuted
	^ isExecuted! !

!GTDebuggerDebugActionEvent methodsFor: 'testing' stamp: 'RogerStebler 3/11/2016 13:53'!
isExecuted: aBoolean
	isExecuted := aBoolean! !

GTDebuggerDebugActionEvent subclass: #GTGlamourWrapperDebuggingActionEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-EventRecorder'!

!GTGlamourWrapperDebuggingActionEvent methodsFor: 'initialization' stamp: 'RogerStebler 3/11/2016 17:54'!
fromDebugAction: aDebugAction
	self flag: 'Find a better way to get type of action'.
	super fromDebugAction: aDebugAction.
	self infoAt: #glamourActionTitle put: aDebugAction asGlamourAction title.! !

GTDebuggerDebugActionEvent subclass: #GTGoAndInspectBytecodeDebugActionEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-EventRecorder'!

!GTGoAndInspectBytecodeDebugActionEvent methodsFor: 'initialization' stamp: 'RogerStebler 3/12/2016 14:50'!
fromDebugAction: aDebugAction
	super fromDebugAction: aDebugAction.
	self infoAt: #selection put: aDebugAction debugger bytecodePresentation selection.! !

GTDebuggerDebugActionEvent subclass: #GTRunToSelectionDebugActionEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-EventRecorder'!

!GTRunToSelectionDebugActionEvent methodsFor: 'initialization' stamp: 'RogerStebler 3/11/2016 18:44'!
fromDebugAction: aDebugAction
	super fromDebugAction: aDebugAction.
	self infoAt: #selection put: aDebugAction debugger selectionInterval.! !

GTDebuggerDebugActionEvent subclass: #GTStepToBytecodeDebugActionEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-EventRecorder'!

!GTStepToBytecodeDebugActionEvent methodsFor: 'initialization' stamp: 'RogerStebler 3/12/2016 14:50'!
fromDebugAction: aDebugAction
	super fromDebugAction: aDebugAction.
	self infoAt: #selection put: aDebugAction debugger bytecodePresentation selection.! !

GTDebuggerDebugActionEvent subclass: #MessageSendDebugActionEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-EventRecorder'!

!MessageSendDebugActionEvent methodsFor: 'initialization' stamp: 'RogerStebler 3/11/2016 18:24'!
fromDebugAction: aDebugAction
	super fromDebugAction: aDebugAction.
	self infoAt: #selector put: aDebugAction selector.! !

GTDebuggerDebugActionEvent subclass: #RunToSelectionDebugActionEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-EventRecorder'!

!RunToSelectionDebugActionEvent methodsFor: 'initialization' stamp: 'RogerStebler 3/11/2016 18:44'!
fromDebugAction: aDebugAction
	super fromDebugAction: aDebugAction.
	self infoAt: #selection put: aDebugAction debugger code getSelection.! !

!GTDebuggerRecorderEvent class methodsFor: 'instance creation' stamp: 'AndreiChis 1/29/2016 14:28'!
fromAnnouncement: anAnnouncement

	^ self new fromAnnouncement: anAnnouncement! !

!GTDebuggerRecorderEvent methodsFor: 'accessing' stamp: 'AndreiChis 1/29/2016 15:36'!
addWindowHashFor: aPresentation

	aPresentation window ifNotNil: [ :aWindow |
		self infoAt: #windowHash put: aWindow identityHash ]! !

!GTDebuggerRecorderEvent methodsFor: 'initialization' stamp: 'AndreiChis 1/29/2016 14:28'!
fromAnnouncement: anAnnouncement
! !

!GTDebuggerRecorderEvent methodsFor: 'accessing' stamp: 'RogerStebler 3/3/2016 17:21'!
infoAt: aSymbol
	^ info at: aSymbol! !

!GTDebuggerRecorderEvent methodsFor: 'accessing' stamp: 'AndreiChis 1/29/2016 14:42'!
infoAt: key put: value
	info ifNil: [ info := Dictionary new ].
	^ info at: key put: value! !

!GTDebuggerRecorderEvent methodsFor: 'initialization' stamp: 'RogerStebler 3/10/2016 18:04'!
initialize
	super initialize.
	timestamp := DateAndTime now.! !

!GTDebuggerRecorderEvent methodsFor: 'accessing' stamp: 'RogerStebler 3/10/2016 18:05'!
timestamp
	^ timestamp! !

GTDebuggerRecorderEvent subclass: #GTDebuggerRecorderOpenEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-EventRecorder'!

!GTDebuggerRecorderOpenEvent class methodsFor: 'instance creation' stamp: 'RogerStebler 3/15/2016 15:49'!
fromDebugger: aDebugger

	^ self new fromDebugger: aDebugger! !

!GTDebuggerRecorderOpenEvent methodsFor: 'initialization' stamp: 'AndreiChis 1/29/2016 15:37'!
fromDebugger: aDebugger

	self infoAt: #debuggerClass put: aDebugger class name.
	self addWindowHashFor: aDebugger! !

GTDebuggerRecorderEvent subclass: #GTGenericStackDebuggerSelectionChangedEvent
	instanceVariableNames: 'debugger newContext'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-EventRecorder'!

!GTGenericStackDebuggerSelectionChangedEvent methodsFor: 'initialization' stamp: 'RogerStebler 3/15/2016 15:46'!
fromAnnouncement: anAnnouncement
	super fromAnnouncement: anAnnouncement.
	
	self infoAt: #newContext put: anAnnouncement newContext asString.
	self addWindowHashFor: anAnnouncement debugger.! !

!GTCodeDebugAction methodsFor: '*GT-Debugger-EventRecorder' stamp: 'RogerStebler 3/15/2016 15:55'!
asRecorderEvent

	^ GTCodeDebugActionEvent fromDebugAction: self! !

!DebugActionAboutToExecute methodsFor: '*GT-Debugger-EventRecorder' stamp: 'RogerStebler 3/11/2016 13:54'!
asRecorderEvent

	^ (debuggingAction asRecorderEvent fromAnnouncement: self)
		isExecuted: false;
		yourself! !
